<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAnalysisName ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAnalysisName
 * @subpackage Arrays
 */
class ArrayOfAnalysisName extends AbstractStructArrayBase
{
    /**
     * The AnalysisName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AnalysisName[]
     */
    public $AnalysisName;
    /**
     * Constructor method for ArrayOfAnalysisName
     * @uses ArrayOfAnalysisName::setAnalysisName()
     * @param \StructType\AnalysisName[] $analysisName
     */
    public function __construct(array $analysisName = array())
    {
        $this
            ->setAnalysisName($analysisName);
    }
    /**
     * Get AnalysisName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AnalysisName[]|null
     */
    public function getAnalysisName()
    {
        return isset($this->AnalysisName) ? $this->AnalysisName : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAnalysisName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnalysisName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnalysisNameForArrayConstraintsFromSetAnalysisName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAnalysisNameAnalysisNameItem) {
            // validation for constraint: itemType
            if (!$arrayOfAnalysisNameAnalysisNameItem instanceof \StructType\AnalysisName) {
                $invalidValues[] = is_object($arrayOfAnalysisNameAnalysisNameItem) ? get_class($arrayOfAnalysisNameAnalysisNameItem) : sprintf('%s(%s)', gettype($arrayOfAnalysisNameAnalysisNameItem), var_export($arrayOfAnalysisNameAnalysisNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AnalysisName property can only contain items of type \StructType\AnalysisName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AnalysisName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AnalysisName[] $analysisName
     * @return \ArrayType\ArrayOfAnalysisName
     */
    public function setAnalysisName(array $analysisName = array())
    {
        // validation for constraint: array
        if ('' !== ($analysisNameArrayErrorMessage = self::validateAnalysisNameForArrayConstraintsFromSetAnalysisName($analysisName))) {
            throw new \InvalidArgumentException($analysisNameArrayErrorMessage, __LINE__);
        }
        if (is_null($analysisName) || (is_array($analysisName) && empty($analysisName))) {
            unset($this->AnalysisName);
        } else {
            $this->AnalysisName = $analysisName;
        }
        return $this;
    }
    /**
     * Add item to AnalysisName value
     * @throws \InvalidArgumentException
     * @param \StructType\AnalysisName $item
     * @return \ArrayType\ArrayOfAnalysisName
     */
    public function addToAnalysisName(\StructType\AnalysisName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AnalysisName) {
            throw new \InvalidArgumentException(sprintf('The AnalysisName property can only contain items of type \StructType\AnalysisName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AnalysisName[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AnalysisName|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AnalysisName|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AnalysisName|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AnalysisName|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AnalysisName|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AnalysisName
     */
    public function getAttributeName()
    {
        return 'AnalysisName';
    }
}
