<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductsName ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProductsName
 * @subpackage Arrays
 */
class ArrayOfProductsName extends AbstractStructArrayBase
{
    /**
     * The ProductsName
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProductsName[]
     */
    public $ProductsName;
    /**
     * Constructor method for ArrayOfProductsName
     * @uses ArrayOfProductsName::setProductsName()
     * @param \StructType\ProductsName[] $productsName
     */
    public function __construct(array $productsName = array())
    {
        $this
            ->setProductsName($productsName);
    }
    /**
     * Get ProductsName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProductsName[]|null
     */
    public function getProductsName()
    {
        return isset($this->ProductsName) ? $this->ProductsName : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProductsName method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductsName method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductsNameForArrayConstraintsFromSetProductsName(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductsNameProductsNameItem) {
            // validation for constraint: itemType
            if (!$arrayOfProductsNameProductsNameItem instanceof \StructType\ProductsName) {
                $invalidValues[] = is_object($arrayOfProductsNameProductsNameItem) ? get_class($arrayOfProductsNameProductsNameItem) : sprintf('%s(%s)', gettype($arrayOfProductsNameProductsNameItem), var_export($arrayOfProductsNameProductsNameItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProductsName property can only contain items of type \StructType\ProductsName, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProductsName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProductsName[] $productsName
     * @return \ArrayType\ArrayOfProductsName
     */
    public function setProductsName(array $productsName = array())
    {
        // validation for constraint: array
        if ('' !== ($productsNameArrayErrorMessage = self::validateProductsNameForArrayConstraintsFromSetProductsName($productsName))) {
            throw new \InvalidArgumentException($productsNameArrayErrorMessage, __LINE__);
        }
        if (is_null($productsName) || (is_array($productsName) && empty($productsName))) {
            unset($this->ProductsName);
        } else {
            $this->ProductsName = $productsName;
        }
        return $this;
    }
    /**
     * Add item to ProductsName value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductsName $item
     * @return \ArrayType\ArrayOfProductsName
     */
    public function addToProductsName(\StructType\ProductsName $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductsName) {
            throw new \InvalidArgumentException(sprintf('The ProductsName property can only contain items of type \StructType\ProductsName, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProductsName[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductsName|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductsName|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductsName|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductsName|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductsName|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductsName
     */
    public function getAttributeName()
    {
        return 'ProductsName';
    }
}
