<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSampleCustomField ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSampleCustomField
 * @subpackage Arrays
 */
class ArrayOfSampleCustomField extends AbstractStructArrayBase
{
    /**
     * The SampleCustomField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SampleCustomField[]
     */
    public $SampleCustomField;
    /**
     * Constructor method for ArrayOfSampleCustomField
     * @uses ArrayOfSampleCustomField::setSampleCustomField()
     * @param \StructType\SampleCustomField[] $sampleCustomField
     */
    public function __construct(array $sampleCustomField = array())
    {
        $this
            ->setSampleCustomField($sampleCustomField);
    }
    /**
     * Get SampleCustomField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SampleCustomField[]|null
     */
    public function getSampleCustomField()
    {
        return isset($this->SampleCustomField) ? $this->SampleCustomField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSampleCustomField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSampleCustomField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSampleCustomFieldForArrayConstraintsFromSetSampleCustomField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSampleCustomFieldSampleCustomFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfSampleCustomFieldSampleCustomFieldItem instanceof \StructType\SampleCustomField) {
                $invalidValues[] = is_object($arrayOfSampleCustomFieldSampleCustomFieldItem) ? get_class($arrayOfSampleCustomFieldSampleCustomFieldItem) : sprintf('%s(%s)', gettype($arrayOfSampleCustomFieldSampleCustomFieldItem), var_export($arrayOfSampleCustomFieldSampleCustomFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SampleCustomField property can only contain items of type \StructType\SampleCustomField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SampleCustomField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SampleCustomField[] $sampleCustomField
     * @return \ArrayType\ArrayOfSampleCustomField
     */
    public function setSampleCustomField(array $sampleCustomField = array())
    {
        // validation for constraint: array
        if ('' !== ($sampleCustomFieldArrayErrorMessage = self::validateSampleCustomFieldForArrayConstraintsFromSetSampleCustomField($sampleCustomField))) {
            throw new \InvalidArgumentException($sampleCustomFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($sampleCustomField) || (is_array($sampleCustomField) && empty($sampleCustomField))) {
            unset($this->SampleCustomField);
        } else {
            $this->SampleCustomField = $sampleCustomField;
        }
        return $this;
    }
    /**
     * Add item to SampleCustomField value
     * @throws \InvalidArgumentException
     * @param \StructType\SampleCustomField $item
     * @return \ArrayType\ArrayOfSampleCustomField
     */
    public function addToSampleCustomField(\StructType\SampleCustomField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SampleCustomField) {
            throw new \InvalidArgumentException(sprintf('The SampleCustomField property can only contain items of type \StructType\SampleCustomField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SampleCustomField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SampleCustomField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SampleCustomField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SampleCustomField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SampleCustomField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SampleCustomField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SampleCustomField
     */
    public function getAttributeName()
    {
        return 'SampleCustomField';
    }
}
