<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSamplesParam StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetSamplesParam
 * @subpackage Structs
 */
class GetSamplesParam extends AbstractStructBase
{
    /**
     * The CodiceCampione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodiceCampione;
    /**
     * The CodiceCommessa
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodiceCommessa;
    /**
     * The DataFine
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DataFine;
    /**
     * The DataInizio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DataInizio;
    /**
     * The IdCampione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $IdCampione;
    /**
     * The IncludiEsportati
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IncludiEsportati;
    /**
     * The Lingua
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Lingua;
    /**
     * Constructor method for GetSamplesParam
     * @uses GetSamplesParam::setCodiceCampione()
     * @uses GetSamplesParam::setCodiceCommessa()
     * @uses GetSamplesParam::setDataFine()
     * @uses GetSamplesParam::setDataInizio()
     * @uses GetSamplesParam::setIdCampione()
     * @uses GetSamplesParam::setIncludiEsportati()
     * @uses GetSamplesParam::setLingua()
     * @param string $codiceCampione
     * @param string $codiceCommessa
     * @param string $dataFine
     * @param string $dataInizio
     * @param int $idCampione
     * @param bool $includiEsportati
     * @param string $lingua
     */
    public function __construct($codiceCampione = null, $codiceCommessa = null, $dataFine = null, $dataInizio = null, $idCampione = null, $includiEsportati = null, $lingua = null)
    {
        $this
            ->setCodiceCampione($codiceCampione)
            ->setCodiceCommessa($codiceCommessa)
            ->setDataFine($dataFine)
            ->setDataInizio($dataInizio)
            ->setIdCampione($idCampione)
            ->setIncludiEsportati($includiEsportati)
            ->setLingua($lingua);
    }
    /**
     * Get CodiceCampione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodiceCampione()
    {
        return isset($this->CodiceCampione) ? $this->CodiceCampione : null;
    }
    /**
     * Set CodiceCampione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codiceCampione
     * @return \StructType\GetSamplesParam
     */
    public function setCodiceCampione($codiceCampione = null)
    {
        // validation for constraint: string
        if (!is_null($codiceCampione) && !is_string($codiceCampione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codiceCampione, true), gettype($codiceCampione)), __LINE__);
        }
        if (is_null($codiceCampione) || (is_array($codiceCampione) && empty($codiceCampione))) {
            unset($this->CodiceCampione);
        } else {
            $this->CodiceCampione = $codiceCampione;
        }
        return $this;
    }
    /**
     * Get CodiceCommessa value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodiceCommessa()
    {
        return isset($this->CodiceCommessa) ? $this->CodiceCommessa : null;
    }
    /**
     * Set CodiceCommessa value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codiceCommessa
     * @return \StructType\GetSamplesParam
     */
    public function setCodiceCommessa($codiceCommessa = null)
    {
        // validation for constraint: string
        if (!is_null($codiceCommessa) && !is_string($codiceCommessa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codiceCommessa, true), gettype($codiceCommessa)), __LINE__);
        }
        if (is_null($codiceCommessa) || (is_array($codiceCommessa) && empty($codiceCommessa))) {
            unset($this->CodiceCommessa);
        } else {
            $this->CodiceCommessa = $codiceCommessa;
        }
        return $this;
    }
    /**
     * Get DataFine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataFine()
    {
        return isset($this->DataFine) ? $this->DataFine : null;
    }
    /**
     * Set DataFine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataFine
     * @return \StructType\GetSamplesParam
     */
    public function setDataFine($dataFine = null)
    {
        // validation for constraint: string
        if (!is_null($dataFine) && !is_string($dataFine)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataFine, true), gettype($dataFine)), __LINE__);
        }
        if (is_null($dataFine) || (is_array($dataFine) && empty($dataFine))) {
            unset($this->DataFine);
        } else {
            $this->DataFine = $dataFine;
        }
        return $this;
    }
    /**
     * Get DataInizio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataInizio()
    {
        return isset($this->DataInizio) ? $this->DataInizio : null;
    }
    /**
     * Set DataInizio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataInizio
     * @return \StructType\GetSamplesParam
     */
    public function setDataInizio($dataInizio = null)
    {
        // validation for constraint: string
        if (!is_null($dataInizio) && !is_string($dataInizio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataInizio, true), gettype($dataInizio)), __LINE__);
        }
        if (is_null($dataInizio) || (is_array($dataInizio) && empty($dataInizio))) {
            unset($this->DataInizio);
        } else {
            $this->DataInizio = $dataInizio;
        }
        return $this;
    }
    /**
     * Get IdCampione value
     * @return int|null
     */
    public function getIdCampione()
    {
        return $this->IdCampione;
    }
    /**
     * Set IdCampione value
     * @param int $idCampione
     * @return \StructType\GetSamplesParam
     */
    public function setIdCampione($idCampione = null)
    {
        // validation for constraint: int
        if (!is_null($idCampione) && !(is_int($idCampione) || ctype_digit($idCampione))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idCampione, true), gettype($idCampione)), __LINE__);
        }
        $this->IdCampione = $idCampione;
        return $this;
    }
    /**
     * Get IncludiEsportati value
     * @return bool|null
     */
    public function getIncludiEsportati()
    {
        return $this->IncludiEsportati;
    }
    /**
     * Set IncludiEsportati value
     * @param bool $includiEsportati
     * @return \StructType\GetSamplesParam
     */
    public function setIncludiEsportati($includiEsportati = null)
    {
        // validation for constraint: boolean
        if (!is_null($includiEsportati) && !is_bool($includiEsportati)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includiEsportati, true), gettype($includiEsportati)), __LINE__);
        }
        $this->IncludiEsportati = $includiEsportati;
        return $this;
    }
    /**
     * Get Lingua value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLingua()
    {
        return isset($this->Lingua) ? $this->Lingua : null;
    }
    /**
     * Set Lingua value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lingua
     * @return \StructType\GetSamplesParam
     */
    public function setLingua($lingua = null)
    {
        // validation for constraint: string
        if (!is_null($lingua) && !is_string($lingua)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lingua, true), gettype($lingua)), __LINE__);
        }
        if (is_null($lingua) || (is_array($lingua) && empty($lingua))) {
            unset($this->Lingua);
        } else {
            $this->Lingua = $lingua;
        }
        return $this;
    }
}
