<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SampleCustomField StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SampleCustomField
 * @subpackage Structs
 */
class SampleCustomField extends AbstractStructBase
{
    /**
     * The IdCustomField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $IdCustomField;
    /**
     * The Ordine
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Ordine;
    /**
     * The Titolo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Titolo;
    /**
     * The Valore
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Valore;
    /**
     * Constructor method for SampleCustomField
     * @uses SampleCustomField::setIdCustomField()
     * @uses SampleCustomField::setOrdine()
     * @uses SampleCustomField::setTitolo()
     * @uses SampleCustomField::setValore()
     * @param int $idCustomField
     * @param int $ordine
     * @param string $titolo
     * @param string $valore
     */
    public function __construct($idCustomField = null, $ordine = null, $titolo = null, $valore = null)
    {
        $this
            ->setIdCustomField($idCustomField)
            ->setOrdine($ordine)
            ->setTitolo($titolo)
            ->setValore($valore);
    }
    /**
     * Get IdCustomField value
     * @return int|null
     */
    public function getIdCustomField()
    {
        return $this->IdCustomField;
    }
    /**
     * Set IdCustomField value
     * @param int $idCustomField
     * @return \StructType\SampleCustomField
     */
    public function setIdCustomField($idCustomField = null)
    {
        // validation for constraint: int
        if (!is_null($idCustomField) && !(is_int($idCustomField) || ctype_digit($idCustomField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idCustomField, true), gettype($idCustomField)), __LINE__);
        }
        $this->IdCustomField = $idCustomField;
        return $this;
    }
    /**
     * Get Ordine value
     * @return int|null
     */
    public function getOrdine()
    {
        return $this->Ordine;
    }
    /**
     * Set Ordine value
     * @param int $ordine
     * @return \StructType\SampleCustomField
     */
    public function setOrdine($ordine = null)
    {
        // validation for constraint: int
        if (!is_null($ordine) && !(is_int($ordine) || ctype_digit($ordine))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($ordine, true), gettype($ordine)), __LINE__);
        }
        $this->Ordine = $ordine;
        return $this;
    }
    /**
     * Get Titolo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitolo()
    {
        return isset($this->Titolo) ? $this->Titolo : null;
    }
    /**
     * Set Titolo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $titolo
     * @return \StructType\SampleCustomField
     */
    public function setTitolo($titolo = null)
    {
        // validation for constraint: string
        if (!is_null($titolo) && !is_string($titolo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titolo, true), gettype($titolo)), __LINE__);
        }
        if (is_null($titolo) || (is_array($titolo) && empty($titolo))) {
            unset($this->Titolo);
        } else {
            $this->Titolo = $titolo;
        }
        return $this;
    }
    /**
     * Get Valore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValore()
    {
        return isset($this->Valore) ? $this->Valore : null;
    }
    /**
     * Set Valore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valore
     * @return \StructType\SampleCustomField
     */
    public function setValore($valore = null)
    {
        // validation for constraint: string
        if (!is_null($valore) && !is_string($valore)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valore, true), gettype($valore)), __LINE__);
        }
        if (is_null($valore) || (is_array($valore) && empty($valore))) {
            unset($this->Valore);
        } else {
            $this->Valore = $valore;
        }
        return $this;
    }
}
