<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SampleReports StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SampleReports
 * @subpackage Structs
 */
class SampleReports extends AbstractStructBase
{
    /**
     * The CodiceCampione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodiceCampione;
    /**
     * The FileData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FileData;
    /**
     * The FileName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FileName;
    /**
     * The IdCampione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $IdCampione;
    /**
     * Constructor method for SampleReports
     * @uses SampleReports::setCodiceCampione()
     * @uses SampleReports::setFileData()
     * @uses SampleReports::setFileName()
     * @uses SampleReports::setIdCampione()
     * @param string $codiceCampione
     * @param string $fileData
     * @param string $fileName
     * @param int $idCampione
     */
    public function __construct($codiceCampione = null, $fileData = null, $fileName = null, $idCampione = null)
    {
        $this
            ->setCodiceCampione($codiceCampione)
            ->setFileData($fileData)
            ->setFileName($fileName)
            ->setIdCampione($idCampione);
    }
    /**
     * Get CodiceCampione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodiceCampione()
    {
        return isset($this->CodiceCampione) ? $this->CodiceCampione : null;
    }
    /**
     * Set CodiceCampione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codiceCampione
     * @return \StructType\SampleReports
     */
    public function setCodiceCampione($codiceCampione = null)
    {
        // validation for constraint: string
        if (!is_null($codiceCampione) && !is_string($codiceCampione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codiceCampione, true), gettype($codiceCampione)), __LINE__);
        }
        if (is_null($codiceCampione) || (is_array($codiceCampione) && empty($codiceCampione))) {
            unset($this->CodiceCampione);
        } else {
            $this->CodiceCampione = $codiceCampione;
        }
        return $this;
    }
    /**
     * Get FileData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFileData()
    {
        return isset($this->FileData) ? $this->FileData : null;
    }
    /**
     * Set FileData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fileData
     * @return \StructType\SampleReports
     */
    public function setFileData($fileData = null)
    {
        // validation for constraint: string
        if (!is_null($fileData) && !is_string($fileData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fileData, true), gettype($fileData)), __LINE__);
        }
        if (is_null($fileData) || (is_array($fileData) && empty($fileData))) {
            unset($this->FileData);
        } else {
            $this->FileData = $fileData;
        }
        return $this;
    }
    /**
     * Get FileName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFileName()
    {
        return isset($this->FileName) ? $this->FileName : null;
    }
    /**
     * Set FileName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fileName
     * @return \StructType\SampleReports
     */
    public function setFileName($fileName = null)
    {
        // validation for constraint: string
        if (!is_null($fileName) && !is_string($fileName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fileName, true), gettype($fileName)), __LINE__);
        }
        if (is_null($fileName) || (is_array($fileName) && empty($fileName))) {
            unset($this->FileName);
        } else {
            $this->FileName = $fileName;
        }
        return $this;
    }
    /**
     * Get IdCampione value
     * @return int|null
     */
    public function getIdCampione()
    {
        return $this->IdCampione;
    }
    /**
     * Set IdCampione value
     * @param int $idCampione
     * @return \StructType\SampleReports
     */
    public function setIdCampione($idCampione = null)
    {
        // validation for constraint: int
        if (!is_null($idCampione) && !(is_int($idCampione) || ctype_digit($idCampione))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idCampione, true), gettype($idCampione)), __LINE__);
        }
        $this->IdCampione = $idCampione;
        return $this;
    }
}
